package com.sun.jmx.snmp;

import java.io.Serializable;

public class SnmpPduFactoryBER implements SnmpPduFactory, Serializable
{
    private static final long serialVersionUID = -3525318344000547635L;
    
    public SnmpPduFactoryBER() {
    }
    
    @Override
    public SnmpPdu decodeSnmpPdu(SnmpMsg snmpMsg) throws SnmpStatusException {
        return snmpMsg.decodeSnmpPdu();
    }
    
    @Override
    public SnmpMsg encodeSnmpPdu(SnmpPdu snmpPdu, int n) throws SnmpStatusException, SnmpTooBigException {
        switch (snmpPdu.version) {
            case 0:
            case 1: {
                SnmpMessage snmpMessage = new SnmpMessage();
                snmpMessage.encodeSnmpPdu((SnmpPdu)snmpPdu, n);
                return snmpMessage;
            }
            case 3: {
                SnmpV3Message snmpV3Message = new SnmpV3Message();
                snmpV3Message.encodeSnmpPdu(snmpPdu, n);
                return snmpV3Message;
            }
            default: {
                return null;
            }
        }
    }
}
